import sys
from PyQt4 import QtGui,QtCore
from PyQt4.QtCore import *
import urllib,urllib2,re

class HughesnetEngine(QTimer):
   updateUiSignal = pyqtSignal(str,int,int,str,int)
   def __init__(self):
      QTimer.__init__(self,parent=None)
      self.timeout.connect(self.updateData)
   def startEngine(self):
      self.updateData()
      self.start(30000)
   def updateData(self):
      current_status = 'gray'
      download_allowance = -1
      upload_allowance = -1
      download_remaining = -1
      upload_remaining = -1
      download_current = -1
      upload_current = -1
      refill = -1
      refill_amount = -1
      fap_soup = False
      status_soup = False
      try:
         fap_soup =urllib.urlopen('http://192.168.0.1/stlui/user/allowance_request.html').read()
      except:
         fap_soup = False # Just to be sure ...
      if fap_soup != False:
         fap_soup = re.sub('<.*?>','\n',fap_soup)
         fap_soup = re.sub('&nbsp;',' ',fap_soup)
         fap_soup = re.sub('\s{2,}','\n',fap_soup)
         fap_parsed = fap_soup.split('\n')
         x = 0
         while x < len(fap_parsed):
            if fap_parsed[x] == "Maximum Download Bank (MB)":
               download_allowance = int(fap_parsed[x+1])
            if fap_parsed[x] == "Allowance Remaining (MB)":
               download_remaining = int(fap_parsed[x+1])
            if fap_parsed[x] == 'Time Until Allowance Refill':
               refill = str(fap_parsed[x+1])
            if fap_parsed[x] == 'Plan Refill Amount (MB)':
               refill_amount = int(fap_parsed[x+1])
            x = x +1

      try:
         status_soup = urllib.urlopen('http://192.168.0.1/stlui/user/status_bar.html').read()
      except:
         current_status = 'gray'
         status_soup = False # Again, just to be sure
      if not status_soup == False:
         if status_soup.find('red.gif') > 0 :
            current_status = 'red'
         elif status_soup.find('yellow.gif') > 0:
            current_status = 'yellow'
         elif status_soup.find('orange.gif') > 0:
            current_status = 'orange'
         elif status_soup.find('green.gif') > 0:
            current_status = 'green'
         else:
            current_status = 'gray'

      self.updateUiSignal.emit(current_status,download_remaining,download_allowance,
     refill,refill_amount)
